<template>
  <ChatRoomVue
    v-if="inChat"
    :selectedChat="selectedChat"
    @home="home"
    :nivelUsuario="nivelUsuario"
  />
  <ChatListVue
    v-if="!inChat"
    :chatList="chatList"
    @selected="select"
    :nivelUsuario="nivelUsuario"
  />
</template>

<script setup lang="ts">
import { Ref, ref } from "vue";
import { Chat } from "../data/models/Chat";
import ChatListVue from "./Home/ChatList.vue";
import ChatRoomVue from "./Home/ChatRoom.vue";
import { backendCollector } from "../data/collectors/backendCollector";
import { router } from "../router";

const inChat = ref(false);
const loggedIn = await backendCollector.login();
if (!loggedIn.success) {
  if (loggedIn.code == 401 || loggedIn.code == 404) {
    router.replace("/loginForm").then(() => {
      window.location.reload();
    });
  } else {
    console.log(
      `error haciendo login: {code: ${loggedIn.code}, error: ${loggedIn.error}`
    );
  }
} 
const nivelUsuario = loggedIn.data?.nivel ?? "usuario";
const fetched = await backendCollector.getChatList();
const chatList: Ref<Chat[]> = ref(fetched.data ?? []);
const selectedChat = ref(chatList.value[0]);

function select(chat: Chat) {
  selectedChat.value = chat;
  inChat.value = true;
}
function home() {
  inChat.value = false;
}
</script>
